proc add_rgb {rgb1 rgb2} {
  for {set i 0} {$i<3} {incr i} {
    set value1 [lindex $rgb1 $i]
    set value2 [lindex $rgb2 $i]
    set newvalue [expr {$value1+$value2}]
    if {$newvalue<0} {
      set newvalue 0
    } elseif {$newvalue>65535} {
      set newvalue 65535
    }
    lappend newrgb $newvalue
  }
  return $newrgb
}

proc color_from_rgb {rgb} {
  set r [lindex $rgb 0]
  set g [lindex $rgb 1]
  set b [lindex $rgb 2]
  return [format "#%04x%04x%04x" $r $g $b]
}

proc arrow_button {dir w args} {
  switch -- $dir {
    up {
      set chardata {
	"     #     "
	"    ##.    "
	"    ##.    "
	"   ##+..   "
	"   ##+..   "
	"  ##+++..  "
	"  ##+++..  "
	" ##+++++.. "
	" ##+++++.. "
	"##........."
	"..........."
      }
    }
    down {
      set chardata {
	"..........."
	"##........."
	" ##+++++.. "
	" ##+++++.. "
	"  ##+++..  "
	"  ##+++..  "
	"   ##+..   "
	"   ##+..   "
	"    ##.    "
	"    ##.    "
	"     #     "
      }
    }
  }
  eval button $w -borderwidth 0 $args
  set normal_color [$w cget -background]
  set normal_rgb [winfo rgb $w $normal_color]
  set highlight_rgb [add_rgb $normal_rgb {32768 32768 32768}]
  set shadow_rgb [add_rgb $normal_rgb {-32768 -32768 -32768}]
  set highlight_color [color_from_rgb $highlight_rgb]
  set shadow_color [color_from_rgb $shadow_rgb]
  set image [image create photo -width 11 -height 11]
  set row 0
  foreach line $chardata {
    set linelen [string length $line]
    for {set i 0} {$i<$linelen} {incr i} {
      set char [string index $line $i]
      if {$char!=" "} {
	switch -- [string index $line $i] {
	  "+" { set color $normal_color }
	  "#" { set color $highlight_color }
	  "." { set color $shadow_color }
	  default { assert {0} }
	}
	$image put $color -to $i $row
      }
    }
    incr row
  }
  $w configure -image $image
  return $w
}
