proc option_editor_option_changed {option} {
  option_changed $option
  save_options
}

proc option_editor_close {} {
  destroy .optiondlg
}

proc option_dialog_dir_menu_command_changed {var1 var2 op} {
  option_editor_option_changed $var2
}

proc open_option_dialog {} {
  let w .optiondlg {
    toplevel $w -class Dialog
    wm group $w .
    wm title $w "Edit Options"
    global options
    foreach {label option} {
      "Entering a blank line toggles compact mode" enter_blank_toggles_compact
      "Command line is always in the menu bar"     cmdline_stays_at_top
      "Command line hides menus\n(use popup menu instead)"
                                                   no_menus_with_top_cmdline
      "Start in compact mode"                      start_compact
      "Double click prompt to remove command"      double_click_prompt
      "Only expand if output occurs"               expand_only_for_output
      "FVWM geometry hack"                         fvwm_geometry_hack
      "No seperate command line"                   cmdline_in_output
    } {
      let w $w.$option {
	checkbutton $w -text $label
	$w configure -command [list option_editor_option_changed $option]
	$w configure -variable options($option)
	pack $w -side top -anchor w 
      }
    }
    let w $w.separator {
      frame $w -height 2 -borderwidth 1 -relief sunken
      pack $w -side top -fill x
    }
    let w $w.dir_menu_cmd_frame {
      frame $w
      label $w.label -text "Dir Menu Command: "
      pack $w.label -side left
      entry $w.entry -width 20 -textvariable options(dir_menu_command)
      global options
      trace variable options(dir_menu_command) "w" option_dialog_dir_menu_command_changed
      pack $w.entry -side left -expand 1 -fill x
      pack $w -side top -expand 1 -fill x
    }
    let w $w.bottom_separator {
      frame $w -height 2 -borderwidth 1 -relief sunken
      pack $w -side top -fill x
    }
    let w $w.close_button {
      button $w -text "Close" -command option_editor_close
      pack $w -side top
    }
  }
}

proc edit_options {window} {
  if {[winfo exists .optiondlg]} {
    wm deiconify .optiondlg
  } else {
    open_option_dialog
  }
  center_window .optiondlg $window
}
