/********************************************************/
/* Gsh Copyright (C) 1999 Vaughn Cato                   */
/* See the file "LICENSE", included with this software, */
/* for license information.                             */
/********************************************************/
#include "expectlist.h"

#include <stdlib.h>
#include <string.h>

void DeleteExpectList(ExpectList **elpp)
{
  while (*elpp) {
    ExpectList *current = *elpp;
    ExpectList *next = current->next;
    free(current->pattern);
    free(current->body);
    free(current);
    *elpp = next;
  }
}

void AddToExpectList(ExpectList **elpp,int is_regexp,char *pattern,char *body)
{
  ExpectList *elp = malloc(sizeof(ExpectList));

  elp->is_regexp = is_regexp;
  elp->pattern = strdup(pattern);
  elp->body = strdup(body);
  elp->next = *elpp;
  *elpp = elp;
}
