/********************************************************/
/* Gsh Copyright (C) 1999 Vaughn Cato                   */
/* See the file "LICENSE", included with this software, */
/* for license information.                             */
/********************************************************/
#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>

static void hup_handler(int signum)
{
  fprintf(stderr,"forktest: Caught HUP\n");
  exit(EXIT_FAILURE);
}

int main(int argc,char **argv)
{
  {
    void (*old_handler)(int) = signal(SIGHUP,hup_handler);
  }
  {
    int result = fork();
    if (result==0) {
      int count = 10;
      while (count-- > 0) {
	fprintf(stderr,"Child running %d\n",count);
	sleep(1);
      }
    }
  }
  fprintf(stderr,"forktest> ");
  fgetc(stdin);
}
