#include "timer.h"

#include <stdio.h>

void BeginTiming(Timer *timer)
{
  struct timezone tz;

  if (timer->active) {
    fprintf(stderr,"Called BeginTimer on an active timer\n");
    abort();
  }
  gettimeofday(&timer->start,&tz);
  timer->active = 1;
}

void EndTiming(Timer *timer)
{
  struct timezone tz;
  struct timeval tv;

  if (!timer->active) {
    fprintf(stderr,"Called EndTiming on an inactive timer\n");
    abort();
  }
  gettimeofday(&tv,&tz);
  {
    struct timeval *stv = &timer->start;

    timer->total_time += 
      (tv.tv_sec-stv->tv_sec)*1000000 + ((int)tv.tv_usec-(int)stv->tv_usec);
  }
  timer->active = 0;
}

void PrintTimer(Timer *timer,const char *desc)
{
  fprintf(stderr,"%s: %g secs\n",desc,timer->total_time/1000000.0);
}

