#include "util.h"

#include <stdlib.h>

void ListObjAppendBytes(Tcl_Obj *obj,const char *str,int len)
{
  Tcl_Obj *str_obj = Tcl_NewStringObj((char *)str,len);
  Tcl_IncrRefCount(str_obj);
  Tcl_ListObjAppendElement(NULL,obj,str_obj);
  Tcl_DecrRefCount(str_obj);
}

void ListObjAppendInt(Tcl_Obj *obj,int value)
{
  Tcl_Obj *int_obj = Tcl_NewIntObj(value);
  Tcl_IncrRefCount(int_obj);
  Tcl_ListObjAppendElement(NULL,obj,int_obj);
  Tcl_DecrRefCount(int_obj);
}

void ListObjAppendString(Tcl_Obj *obj,const char *str)
{
  ListObjAppendBytes(obj,str,strlen(str));
}

void *CheckAlloc(int size)
{
  void *result = malloc(size);
  if (!result) {
    fprintf(stderr,"Error allocating memory\n");
    exit(EXIT_FAILURE);
  }
  return result;
}
